## xrootd 5.4.3

=== debian/changelog ===
xrootd (5.4.3-2) unstable; urgency=medium

  * Update the list of architectures for which the ceph module is built

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Mon, 13 Jun 2022 13:58:58 +0200

xrootd (5.4.3-1) unstable; urgency=medium

  * Update to version 5.4.3
  * Drop patches accepted upstream or previously backported
  * Add Build-Depends python3-wheel
  * Use environment variable DEB_PYTHON_INSTALL_LAYOUT=deb during install

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Fri, 10 Jun 2022 18:43:22 +0200

xrootd (5.4.2-2) unstable; urgency=medium

  * Improve detection of when libatomic is needed - send patch upstream
  * Fix sphinx doc
  * Backport fixes from upstream git master (OpenSSL 3, Python 3.10)
  * Add Build-Depends python3-pip

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sat, 23 Apr 2022 23:53:20 +0200

xrootd (5.4.2-1) unstable; urgency=medium

  * Update to version 5.4.2
  * More OpenSSL 3 fixes (Closes: #1006409)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Fri, 04 Mar 2022 10:17:34 +0100

=== debian/control ===
Source: xrootd
Section: net
Priority: optional
Standards-Version: 4.6.1
Build-Depends:
 debhelper (>= 13),
 dh-python,
 cmake (>= 3.1),
 pkg-config,
 libfuse-dev [linux-any kfreebsd-any],
 libkrb5-dev,
 libcurl4-openssl-dev,
 libtinyxml-dev,
 libxml2-dev,
 ncurses-dev,
 libssl-dev,
 libreadline-dev,
 zlib1g-dev,
 doxygen,
 graphviz,
 libsystemd-dev [linux-any],
 python3-dev,
 python3-pip,
 python3-wheel,
 python3-sphinx,
 libjson-c-dev,
 libmacaroons-dev,
 uuid-dev,
 voms-dev,
 libscitokens-dev,
 davix-dev,
 librados-dev [i386 amd64 armel armhf arm64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
 libradospp-dev [i386 amd64 armel armhf arm64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
 libradosstriper-dev [i386 amd64 armel armhf arm64 mips mipsel mips64el powerpc ppc64el riscv64 s390x]
Homepage: http://xrootd.org/
Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
Vcs-Browser: https://salsa.debian.org/ellert/xrootd
Vcs-Git: https://salsa.debian.org/ellert/xrootd.git

Package: xrootd-server
Architecture: any
Multi-Arch: foreign
Section: net
Depends:
 xrootd-plugins (= ${binary:Version}),
 xrootd-server-plugins (= ${binary:Version}),
 expect,
 logrotate,
 adduser,
 ${perl:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Description: Extended ROOT file server
 The Extended root file server consists of a file server called xrootd
 and a cluster management server called cmsd.
 .
 The xrootd server was developed for the root analysis framework to
 serve root files. However, the server is agnostic to file types and
 provides POSIX-like access to any type of file.
 .
 The cmsd server is the next generation version of the olbd server,
 originally developed to cluster and load balance Objectivity/DB AMS
 database servers. It provides enhanced capability along with lower
 latency and increased throughput.

Package: libxrdapputils2
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Utilities library for xrootd applications
 This package contains the xrootd utilities library for applications.

Package: libxrdcrypto2
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Cryptograpic library for xrootd
 This package contains the xrootd cryptograpic library.

Package: libxrdcryptolite2
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Light version of cryptograpic library for xrootd
 This package contains the light version of the xrootd cryptograpic library.

Package: libxrdutils3
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Utilities library for xrootd
 This package contains the xrootd utilities library.

Package: libxrdxml3
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: XML library for xrootd
 This package contains the xrootd XML library.

Package: xrootd-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Plugins used by xrootd servers and clients
 This package contains plugins used by the xrootd servers and clients.

Package: libxrootd-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libxrdapputils2 (= ${binary:Version}),
 libxrdcrypto2 (= ${binary:Version}),
 libxrdcryptolite2 (= ${binary:Version}),
 libxrdutils3 (= ${binary:Version}),
 libxrdxml3 (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for xrootd
 This package contains header files and development libraries for xrootd
 development.

Package: libxrdcl3
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 xrootd-plugins (= ${binary:Version}),
 xrootd-client-plugins(= ${binary:Version})
Description: Client library for xrootd
 This package contains the xrootd client library.

Package: libxrdffs3
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: File protocol library for xrootd
 This package contains the xrootd file protocol library.

Package: libxrdposix3
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Posix interface library for xrootd
 This package contains the xrootd Posix interface library.

Package: libxrdssilib2
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Server internals library for xrootd
 This package contains an xrootd server internals library.

Package: libxrdssishmap2
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Server internals library for xrootd
 This package contains an xrootd server internals library.

Package: xrootd-client-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Plugins used by xrootd clients
 This package contains plugins used by xrootd clients.

Package: xrootd-client-http-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: HTTP client plugin for XRootD client
 This package contains an XRootD client plugin which allows XRootD to
 interact with HTTP repositories.

Package: libxrootd-client-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libxrdcl3 (= ${binary:Version}),
 libxrdffs3 (= ${binary:Version}),
 libxrdposix3 (= ${binary:Version}),
 libxrootd-dev (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for xrootd clients
 This package contains header files and development libraries for xrootd
 client development.

Package: libxrdhttputils2
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: HTTP protocol utilities library for xrootd
 This package contains the xrootd HTTP protocol utilities library.

Package: libxrdserver3
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 xrootd-plugins (= ${binary:Version}),
 xrootd-server-plugins(= ${binary:Version})
Description: Server library for xrootd
 This package contains the xrootd server library.

Package: xrootd-server-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Plugins used by xrootd servers
 This package contains plugins used by xrootd servers.

Package: libxrootd-server-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libxrdhttputils2 (= ${binary:Version}),
 libxrdserver3 (= ${binary:Version}),
 libxrootd-dev (= ${binary:Version}),
 libxrootd-client-dev (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for xrootd servers
 This package contains header files and development libraries for xrootd
 server development.

Package: libxrootd-private-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libxrdssilib2 (= ${binary:Version}),
 libxrdssishmap2 (= ${binary:Version}),
 libxrootd-dev (= ${binary:Version}),
 libxrootd-client-dev (= ${binary:Version}),
 libxrootd-server-dev (= ${binary:Version}),
 ${misc:Depends}
Description: Private xrootd headers
 This package contains some private xrootd headers. Backward and forward
 compatibility between versions is not guaranteed for these headers.

Package: xrootd-client
Architecture: any
Multi-Arch: foreign
Section: net
Depends:
 xrootd-plugins (= ${binary:Version}),
 xrootd-client-plugins(= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Xrootd command line client tools
 This package contains the command line tools used to communicate with
 xrootd servers.

Package: xrootd-fuse
Architecture: linux-any kfreebsd-any
Multi-Arch: foreign
Section: net
Depends:
 xrootd-plugins (= ${binary:Version}),
 xrootd-client-plugins (= ${binary:Version}),
 fuse,
 ${shlibs:Depends},
 ${misc:Depends}
Description: Xrootd FUSE tool
 This package contains the FUSE (file system in user space) xrootd mount
 tool.

Package: xrootd-voms-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: VOMS attribute extractor plugin for XRootD
 This package contains the xrootd VOMS attribute extractor plugin.

Package: xrootd-scitokens-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: SciTokens authorization support for XRootD
 This ACC (authorization) plugin for the XRootD framework utilizes the
 SciTokens library to validate and extract authorization claims from a
 SciToken passed during a transfer. Configured appropriately, this
 allows the XRootD server admin to delegate authorization decisions for
 a subset of the namespace to an external issuer.

Package: libxrdcephposix0
Architecture: i386 amd64 armel armhf arm64 mips mipsel mips64el powerpc ppc64el riscv64 s390x
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Ceph posix library for xrootd
 This package contains an xrootd library used by the ceph plugins.

Package: xrootd-ceph-plugins
Architecture: i386 amd64 armel armhf arm64 mips mipsel mips64el powerpc ppc64el riscv64 s390x
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: XRootD plugin for interfacing with the Ceph storage platform
 The xrootd-ceph is an OSS layer plugin for the XRootD server for
 interfacing with the Ceph storage platform.

Package: python3-xrootd
Architecture: any
Multi-Arch: foreign
Section: python
Provides:
 ${python3:Provides}
Depends:
 xrootd-plugins (= ${binary:Version}),
 xrootd-client-plugins (= ${binary:Version}),
 ${python3:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Description: Python 3 bindings for xrootd
 This package contains Python 3 bindings for xrootd.

Package: xrootd-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 ${sphinxdoc:Depends},
 ${misc:Depends}
Built-Using:
 ${sphinxdoc:Built-Using}
Description: Developer documentation for the xrootd libraries
 This package contains the API documentation of the xrootd libraries.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Disable ceph dependent packages for architectures without ceph
# This list should match the Build-Depends on ceph libraries in debian/control
#
# Ceph requires boost-context and boost-coroutine
# These are only available on these Debian architectures:
#   i386 hurd-i386 kfreebsd-i386 amd64 kfreebsd-amd64 armel armhf arm64
#   mips mipsel mips64el powerpc ppc64el riscv64 s390x
#
# Ceph requires Java
# Java is not available on these Debian architectures:
#   hppa hurd-i386 kfreebsd-i386 kfreebsd-amd64
ifneq ($(filter $(DEB_HOST_ARCH),i386 amd64 armel armhf arm64 mips mipsel mips64el powerpc ppc64el riscv64 s390x),)
CEPH = ON
else
CEPH = OFF
endif

%:
	dh $@ --with python3 --with sphinxdoc

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DXRDCEPH_SUBMODULE:BOOL=$(CEPH) \
	    -DXRDCLHTTP_SUBMODULE:BOOL=ON \
	    -DPIP_OPTIONS="--no-deps --disable-pip-version-check --verbose" \
	    -DPYTHON_EXECUTABLE:PATH=/usr/bin/python3

override_dh_auto_build:
	dh_auto_build
	doxygen Doxyfile

override_dh_auto_clean:
	dh_auto_clean
	rm -rf doxydoc
	rm -rf bindings/python/docs/build

override_dh_auto_install:
	DEB_PYTHON_INSTALL_LAYOUT=deb dh_auto_install

	rm -f debian/tmp/usr/lib/*/libXrdCephPosix.so

	rm -f debian/tmp/usr/lib/python3/dist-packages/xrootd-*.*-info/direct_url.json
	rm -f debian/tmp/usr/lib/python3/dist-packages/xrootd-*.*-info/RECORD
	[ -r debian/tmp/usr/lib/python3/dist-packages/xrootd-*.*-info/INSTALLER ] && \
	    sed s/pip/dpkg/ \
	    -i debian/tmp/usr/lib/python3/dist-packages/xrootd-*.*-info/INSTALLER

	LD_LIBRARY_PATH=$${LD_LIBRARY_PATH}:$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
	PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3/dist-packages \
	PYTHONDONTWRITEBYTECODE=1 \
	make -C bindings/python/docs html

	# Service unit files
	mkdir -p debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/xrootd@.service debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/xrootd@.socket debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/xrdhttp@.socket debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/cmsd@.service debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/frm_xfrd@.service debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/frm_purged@.service debian/tmp/usr/lib/systemd/system
	mkdir -p debian/tmp/usr/lib/tmpfiles.d
	install -m 644 packaging/rhel/xrootd.tmpfiles debian/tmp/usr/lib/tmpfiles.d/xrootd.conf

	# Server config
	mkdir -p debian/tmp/etc/xrootd
	install -m 644 -p packaging/common/xrootd-clustered.cfg \
	    debian/tmp/etc/xrootd/xrootd-clustered.cfg
	install -m 644 -p packaging/common/xrootd-standalone.cfg \
	    debian/tmp/etc/xrootd/xrootd-standalone.cfg
	install -m 644 -p packaging/common/xrootd-filecache-clustered.cfg \
	    debian/tmp/etc/xrootd/xrootd-filecache-clustered.cfg
	install -m 644 -p packaging/common/xrootd-filecache-standalone.cfg \
	    debian/tmp/etc/xrootd/xrootd-filecache-standalone.cfg
	sed 's!/usr/lib64/!!' packaging/common/xrootd-http.cfg > \
	    debian/tmp/etc/xrootd/xrootd-http.cfg

	# Client config
	mkdir -p debian/tmp/etc/xrootd/client.plugins.d
	install -m 644 -p packaging/common/client.conf \
	    debian/tmp/etc/xrootd/client.conf
	sed 's!/usr/lib/!!' packaging/common/client-plugin.conf.example > \
	    debian/tmp/etc/xrootd/client.plugins.d/client-plugin.conf.example
	sed 's!/usr/local/lib/!!' src/XrdClHttp/config/http.client.conf.example > \
	    debian/tmp/etc/xrootd/client.plugins.d/xrdcl-http-plugin.conf

	chmod 644 debian/tmp/usr/share/xrootd/utils/XrdCmsNotify.pm
	sed 's!/usr/bin/env perl!/usr/bin/perl!' -i \
	    debian/tmp/usr/share/xrootd/utils/netchk \
	    debian/tmp/usr/share/xrootd/utils/XrdCmsNotify.pm \
	    debian/tmp/usr/share/xrootd/utils/XrdOlbMonPerf

	sed 's!/usr/bin/env bash!/bin/bash!' -i \
	    debian/tmp/usr/bin/xrootd-config

	mkdir -p debian/tmp/etc/xrootd/config.d

	mkdir -p debian/tmp/var/log/xrootd
	mkdir -p debian/tmp/var/spool/xrootd

	mkdir -p debian/tmp/etc/logrotate.d
	install -m 644 -p packaging/common/xrootd.logrotate \
	    debian/tmp/etc/logrotate.d/xrootd

	# Documentation
	mkdir -p debian/tmp/usr/share/doc/xrootd
	cp -pr doxydoc/html debian/tmp/usr/share/doc/xrootd
	cp -pr bindings/python/docs/build/html debian/tmp/usr/share/doc/xrootd/python

## xrootd 5.5.0

=== bindings/python/CMakeLists.txt ===

set(SETUP_PY_IN    "${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in")
set(SETUP_PY       "${CMAKE_CURRENT_BINARY_DIR}/setup.py")
set(DEPS           "${CMAKE_CURRENT_SOURCE_DIR}/libs/__init__.py")
set(OUTPUT         "${CMAKE_CURRENT_BINARY_DIR}/python_bindings")
set(XRD_SRCINCDIR  "${CMAKE_SOURCE_DIR}/src")
set(XRD_BININCDIR  "${CMAKE_BINARY_DIR}/src")
set(XRDCL_LIBDIR   "${CMAKE_BINARY_DIR}/src/XrdCl")
set(XRD_LIBDIR     "${CMAKE_BINARY_DIR}/src")
set(XRDCL_INSTALL  "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")

if( PYPI_BUILD )
  set(XRDCL_RPATH  "$ORIGIN/${CMAKE_INSTALL_LIBDIR}")
else()
  set(XRDCL_RPATH  "$ORIGIN/../../..")
endif()

if( "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" )
  if( CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.7 )
    message( "clang 3.5" )
    set( CLANG_PROHIBITED ", '-Wp,-D_FORTIFY_SOURCE=2', '-fstack-protector-strong'" )
  endif()
  if( ( CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 6.0 ) OR ( CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.0 ) )
    message( "clang 6.0" )
    set( CLANG_PROHIBITED ", '-fcf-protection'" )
  endif()
  if( CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 7.0 )
    message( "clang > 7.0" )
    set( CLANG_PROHIBITED ", '-fstack-clash-protection'" )
  endif()
endif()

configure_file(${SETUP_PY_IN} ${SETUP_PY})

string(FIND "${PIP_OPTIONS}" "--prefix" PIP_OPTIONS_PREFIX_POSITION)
if( "${PIP_OPTIONS_PREFIX_POSITION}" EQUAL "-1" )
  string(APPEND PIP_OPTIONS " --prefix \$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX}")
else()
  message(WARNING
        " The pip option --prefix has been set in '${PIP_OPTIONS}' which will change"
        " it from its default value of '--prefix \$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX}'."
        " Make sure this is intentional and that you understand the effects."
        )
endif()

# Check it the Python interpreter has a valid version of pip
execute_process(
        COMMAND ${PYTHON_EXECUTABLE} -m pip --version
        RESULT_VARIABLE VALID_PIP_EXIT_CODE
        OUTPUT_QUIET
)

if ( NOT ${VALID_PIP_EXIT_CODE} EQUAL 0 )
  # Attempt to still install with deprecated invocation of setup.py
  message(WARNING
         " ${PYTHON_EXECUTABLE} does not have a valid pip associated with it."
         " It is recommended that you install a version of pip to install Python"
         " packages and bindings. If you are unable to install a version of pip"
         " through a package manager or with your Python build try using the PyPA's"
         " get-pip.py bootstrapping script ( https://github.com/pypa/get-pip ).\n"
         " The installation of the Python bindings will attempt to continue using"
         " the deprecated method of `${PYTHON_EXECUTABLE} setup.py install`."
         )

  # https://docs.python.org/3/install/#splitting-the-job-up
  add_custom_command(OUTPUT ${OUTPUT}
                     COMMAND ${PYTHON_EXECUTABLE} ${SETUP_PY} --verbose build
                     DEPENDS ${DEPS})

  add_custom_target(python_target ALL DEPENDS ${OUTPUT} XrdCl)

  # Get the distribution name on Debian families
  execute_process( COMMAND grep -i ^NAME= /etc/os-release
                   OUTPUT_VARIABLE DEB_DISTRO )
  STRING(REGEX REPLACE "^NAME=\"" "" DEB_DISTRO "${DEB_DISTRO}")
  STRING(REGEX REPLACE "\".*"     "" DEB_DISTRO "${DEB_DISTRO}")

  if( DEB_DISTRO STREQUAL "Debian" OR DEB_DISTRO STREQUAL "Ubuntu" )
    set(PYTHON_LAYOUT  "unix" CACHE STRING "Python installation layout (deb or unix)")
    set(DEB_INSTALL_ARGS "--install-layout ${PYTHON_LAYOUT}")
  endif()

  install(
    CODE
    "EXECUTE_PROCESS(
      COMMAND /usr/bin/env ${XROOTD_PYBUILD_ENV} ${PYTHON_EXECUTABLE} ${SETUP_PY} install \
                --verbose \
                --prefix \$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX} \
                ${DEB_INSTALL_ARGS}
    )"
  )

else()
  install(
    CODE
    "EXECUTE_PROCESS(
      COMMAND /usr/bin/env ${XROOTD_PYBUILD_ENV} ${PYTHON_EXECUTABLE} -m pip install \
                ${PIP_OPTIONS} \
                ${CMAKE_CURRENT_BINARY_DIR}
      )"
  )
endif()

=== src/XrdClHttp/CMakeLists.txt ===
include_directories(${Davix_INCLUDE_DIRS}/davix)

set(libXrdClHttp_sources
  XrdClHttpPlugInFactory.cc
  XrdClHttpPlugInUtil.cc
  XrdClHttpFilePlugIn.cc
  XrdClHttpFileSystemPlugIn.cc
  XrdClHttpPosix.cc)

set(PLUGIN_NAME "XrdClHttp-${PLUGIN_VERSION}")

add_library(${PLUGIN_NAME} MODULE ${libXrdClHttp_sources})

target_link_libraries(${PLUGIN_NAME} ${Davix_LIBRARIES} XrdCl)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== tests/XrdClTests/tls/CMakeLists.txt ===

include( XRootDCommon )

#-------------------------------------------------------------------------------
# xrdcopy
#-------------------------------------------------------------------------------
if( NOT XRDCL_ONLY )

add_executable(
  xrdcl-tls
  xrdcl-tls.cc )
  
target_link_libraries(
  xrdcl-tls
  XrdCl
  XrdPosix
  XrdXml
  XrdAppUtils
  ${CMAKE_DL_LIBS}
  ${CMAKE_THREAD_LIBS_INIT} )
  
  
add_executable(
  xrdsrv-tls
  xrdsrv-tls.cc )
  
target_link_libraries(
  xrdsrv-tls
  XrdUtils
  ${OPENSSL_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT} )
  
endif()

=== debian/changelog ===
xrootd (5.5.0-1) unstable; urgency=medium

  * Update to version 5.5.0
  * Drop patches accepted upstream
  * Address some warnings from Doxygen
  * Move documentation dependencies to Build-Depends-Indep (Closes: #983343)
  * Update lintian overrides

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sun, 28 Aug 2022 21:22:16 +0200

=== debian/control ===
--- 
+++ 
@@ -16,13 +16,10 @@
  libssl-dev,
  libreadline-dev,
  zlib1g-dev,
- doxygen,
- graphviz,
  libsystemd-dev [linux-any],
  python3-dev,
  python3-pip,
  python3-wheel,
- python3-sphinx,
  libjson-c-dev,
  libmacaroons-dev,
  uuid-dev,
@@ -32,6 +29,11 @@
  librados-dev [i386 amd64 armel armhf arm64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
  libradospp-dev [i386 amd64 armel armhf arm64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
  libradosstriper-dev [i386 amd64 armel armhf arm64 mips mipsel mips64el powerpc ppc64el riscv64 s390x]
+Build-Depends-Indep:
+ dh-sequence-sphinxdoc,
+ doxygen,
+ graphviz,
+ python3-sphinx
 Homepage: http://xrootd.org/
 Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
 Vcs-Browser: https://salsa.debian.org/ellert/xrootd

=== debian/rules ===
--- 
+++ 
@@ -18,19 +18,20 @@
 CEPH = OFF
 endif
 
+BUILD_DOC = $(if $(filter xrootd-doc,$(shell dh_listpackages)),TRUE,FALSE)
+
 %:
-	dh $@ --with python3 --with sphinxdoc
+	dh $@ --with python3
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
 	    -DXRDCEPH_SUBMODULE:BOOL=$(CEPH) \
-	    -DXRDCLHTTP_SUBMODULE:BOOL=ON \
-	    -DPIP_OPTIONS="--no-deps --disable-pip-version-check --verbose" \
-	    -DPYTHON_EXECUTABLE:PATH=/usr/bin/python3
+	    -DENABLE_XRDCLHTTP:BOOL=ON \
+	    -DPIP_OPTIONS="--no-deps --disable-pip-version-check --verbose"
 
 override_dh_auto_build:
 	dh_auto_build
-	doxygen Doxyfile
+	[ "$(BUILD_DOC)" = "FALSE" ] || doxygen Doxyfile
 
 override_dh_auto_clean:
 	dh_auto_clean
@@ -48,10 +49,12 @@
 	    sed s/pip/dpkg/ \
 	    -i debian/tmp/usr/lib/python3/dist-packages/xrootd-*.*-info/INSTALLER
 
+	[ "$(BUILD_DOC)" = "FALSE" ] || ( \
 	LD_LIBRARY_PATH=$${LD_LIBRARY_PATH}:$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
 	PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3/dist-packages \
 	PYTHONDONTWRITEBYTECODE=1 \
-	make -C bindings/python/docs html
+	make -C bindings/python/docs html && \
+	mv bindings/python/docs/build/html bindings/python/docs/build/python )
 
 	# Service unit files
 	mkdir -p debian/tmp/usr/lib/systemd/system
@@ -83,7 +86,9 @@
 	    debian/tmp/etc/xrootd/client.conf
 	sed 's!/usr/lib/!!' packaging/common/client-plugin.conf.example > \
 	    debian/tmp/etc/xrootd/client.plugins.d/client-plugin.conf.example
-	sed 's!/usr/local/lib/!!' src/XrdClHttp/config/http.client.conf.example > \
+	sed -e 's!/usr/lib64/!!' -e 's!-5!!' packaging/common/recorder.conf > \
+	    debian/tmp/etc/xrootd/client.plugins.d/recorder.conf
+	sed 's!/usr/lib64/!!' packaging/common/http.client.conf.example > \
 	    debian/tmp/etc/xrootd/client.plugins.d/xrdcl-http-plugin.conf
 
 	chmod 644 debian/tmp/usr/share/xrootd/utils/XrdCmsNotify.pm
@@ -103,8 +108,3 @@
 	mkdir -p debian/tmp/etc/logrotate.d
 	install -m 644 -p packaging/common/xrootd.logrotate \
 	    debian/tmp/etc/logrotate.d/xrootd
-
-	# Documentation
-	mkdir -p debian/tmp/usr/share/doc/xrootd
-	cp -pr doxydoc/html debian/tmp/usr/share/doc/xrootd
-	cp -pr bindings/python/docs/build/html debian/tmp/usr/share/doc/xrootd/python

## xrootd 5.5.1

=== debian/changelog ===
xrootd (5.5.1-3) unstable; urgency=medium

  * Backport fix from upstream to fix Python 3.11 build (Closes: #1027584)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Fri, 06 Jan 2023 13:29:40 +0100

xrootd (5.5.1-2) unstable; urgency=medium

  * Check all sizes (8, 16, 32, 64) in <atomic> check

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Thu, 20 Oct 2022 09:18:28 +0200

xrootd (5.5.1-1) unstable; urgency=medium

  * Update to version 5.5.1
  * Drop doxygen patch accepted upstream
  * Check operator++ in <atomic> check

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Thu, 20 Oct 2022 03:44:52 +0200

## xrootd 5.5.2

=== debian/changelog ===
xrootd (5.5.2-1) unstable; urgency=medium

  * Update to version 5.5.2
  * Drop patches accepted upstream or previously backported
  * Move systemd unit files back to /lib/systemd/system

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Thu, 09 Feb 2023 19:58:10 +0100

## xrootd 5.5.3

=== CMakeLists.txt ===
#-------------------------------------------------------------------------------
# Project description
#-------------------------------------------------------------------------------
cmake_minimum_required( VERSION 3.1 )

project( XRootD )

set( CMAKE_MODULE_PATH
 ${PROJECT_SOURCE_DIR}/src
 ${PROJECT_SOURCE_DIR}/cmake )

#-------------------------------------------------------------------------------
# A 'plugins' phony target to simplify building build-tree binaries.
# Plugins are responsible for adding themselves to this target, where
# appropriate.
#-------------------------------------------------------------------------------
ADD_CUSTOM_TARGET(plugins)


include( XRootDUtils )
CheckBuildDirectory()

include( XRootDOSDefs )
include( XRootDDefaults )
include( XRootDSystemCheck )
include( XRootDFindLibs )

add_definitions( -DXRDPLUGIN_SOVERSION="${PLUGIN_VERSION}" )

#-------------------------------------------------------------------------------
# Generate the version header
#-------------------------------------------------------------------------------
if (USER_VERSION)
  set(XROOTD_VERSION "${USER_VERSION}")
else ()
execute_process(
  COMMAND ${CMAKE_SOURCE_DIR}/genversion.sh --print-only ${CMAKE_SOURCE_DIR}
  OUTPUT_VARIABLE XROOTD_VERSION
  OUTPUT_STRIP_TRAILING_WHITESPACE )
endif()

add_custom_target(
  XrdVersion.hh
  ${CMAKE_SOURCE_DIR}/genversion.sh --version ${XROOTD_VERSION} ${CMAKE_SOURCE_DIR})

# sigh, yet another ugly hack :(
macro( add_library _target )
  _add_library( ${_target} ${ARGN} )
  add_dependencies( ${_target} XrdVersion.hh )
endmacro()

macro( add_executable _target )
  _add_executable( ${_target} ${ARGN} )
  add_dependencies( ${_target} XrdVersion.hh )
endmacro()

#-------------------------------------------------------------------------------
# Checkout the vomsxrd submodule
#-------------------------------------------------------------------------------
find_package(Git QUIET)
if(GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
  option(GIT_SUBMODULES "Check submodules during build" ON)
  if(GIT_SUBMODULES)
    message(STATUS "Submodule update")
    execute_process(COMMAND ${GIT_EXECUTABLE} submodule update --init --recursive
                    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                    RESULT_VARIABLE GIT_SUBMOD_RESULT)
    if(NOT GIT_SUBMOD_RESULT EQUAL "0")
      message(FATAL_ERROR "git submodule update --init failed with ${GIT_SUBMOD_RESULT}, please checkout submodules")
    endif()
  endif()
endif()

#-------------------------------------------------------------------------------
# Build in subdirectories
#-------------------------------------------------------------------------------
add_subdirectory( src )
add_subdirectory( bindings )

if( BUILD_TESTS )
  ENABLE_TESTING()
  add_subdirectory( tests )
endif()

include( XRootDSummary )


#-------------------------------------------------------------------------------
# Install XRootDConfig.cmake module
#-------------------------------------------------------------------------------

configure_file( "cmake/XRootDConfig.cmake.in" "cmake/XRootDConfig.cmake" @ONLY )

install(
  FILES ${CMAKE_BINARY_DIR}/cmake/XRootDConfig.cmake
  DESTINATION ${CMAKE_INSTALL_DATADIR}/xrootd/cmake )

#-------------------------------------------------------------------------------
# Configure an 'uninstall' target
#-------------------------------------------------------------------------------
CONFIGURE_FILE(
	"${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
	"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
	IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== src/CMakeLists.txt ===
#-------------------------------------------------------------------------------
# If this is a build for pip set up the rpath
# (this is especially important for plugins)
#-------------------------------------------------------------------------------
if( PYPI_BUILD )
  set( CMAKE_INSTALL_RPATH "$ORIGIN" )
  set( CMAKE_INSTALL_RPATH_USE_LINK_PATH true )
endif()

#-------------------------------------------------------------------------------
# XRDCL_LIB_ONLY implies XRDCL_ONLY
#-------------------------------------------------------------------------------
if( XRDCL_LIB_ONLY )
  set ( XRDCL_ONLY TRUE )
endif()

#-------------------------------------------------------------------------------
# Include the subcomponents
#-------------------------------------------------------------------------------
include( XrdUtils )
include( XrdApps )
include( XrdCrypto )
include( XrdPosix )
include( XrdSec )
include( XrdXml )
include( XrdHeaders )

if( BUILD_CRYPTO )
  include( XrdSecgsi )
endif()

if( BUILD_KRB5 )
  include( XrdSeckrb5 )
endif()

if( BUILD_XRDEC )
  include( XrdIsal )
endif()

if( ENABLE_XRDCL )
  add_subdirectory( XrdCl )
endif()

if( BUILD_XRDCLHTTP )
  add_subdirectory( XrdClHttp )
endif()

if( BUILD_XRDEC )
  add_subdirectory( XrdEc )
endif()

if( NOT XRDCL_ONLY )
  include( XrdServer )
  include( XrdDaemons )
  include( XrdFrm )
  include( XrdFfs )
  include( XrdPlugins )
  include( XrdSsi )

  include( XrdPfc )

  if( CMAKE_COMPILER_IS_GNUCXX )
    include( XrdOssCsi )
  endif()

  if( BUILD_HTTP )
    include( XrdHttp )
    include( XrdTpc )
  endif()

  if( BUILD_MACAROONS )
    include( XrdMacaroons )
  endif()

  if( BUILD_VOMS )
    include( XrdVoms )
  endif()

  if( XRDCEPH_SUBMODULE )
    add_subdirectory( XrdCeph )
  endif()

  if( BUILD_SCITOKENS )
    include( XrdSciTokens )
    include( XrdSecztn )
  endif()

endif()

#-------------------------------------------------------------------------------
# Install the utility scripts
#-------------------------------------------------------------------------------
if( NOT XRDCL_ONLY )
install(
  FILES
  ${CMAKE_SOURCE_DIR}/utils/XrdCmsNotify.pm
  ${CMAKE_SOURCE_DIR}/utils/netchk
  ${CMAKE_SOURCE_DIR}/utils/XrdOlbMonPerf
  ${CMAKE_SOURCE_DIR}/utils/cms_monPerf
  DESTINATION ${CMAKE_INSTALL_DATADIR}/xrootd/utils
  PERMISSIONS
  OWNER_EXECUTE OWNER_WRITE OWNER_READ
  GROUP_EXECUTE GROUP_READ
  WORLD_EXECUTE WORLD_READ )
endif()

if( NOT XRDCL_LIB_ONLY )
#-------------------------------------------------------------------------------
# Install xrootd-config
#-------------------------------------------------------------------------------
install(
  CODE "
    EXECUTE_PROCESS(
      COMMAND cat ${CMAKE_SOURCE_DIR}/utils/xrootd-config
      COMMAND sed -e \"s/__VERSION__/${XROOTD_VERSION}/\"
      COMMAND sed -e \"s|__INCLUDEDIR__|${CMAKE_INSTALL_INCLUDEDIR}|\"
      COMMAND sed -e \"s/__PLUGIN_VERSION__/${PLUGIN_VERSION}/\"
      COMMAND sed -e \"s|__PREFIX__|${CMAKE_INSTALL_PREFIX}|\"
      OUTPUT_FILE \$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}/xrootd-config )
    EXECUTE_PROCESS(
      COMMAND chmod 755 \$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}/xrootd-config )"
)

#-------------------------------------------------------------------------------
# Post process man pages
#-------------------------------------------------------------------------------
install(
  CODE "
    FILE(GLOB MANPAGES
      \"\$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_MANDIR}/man[1,8]/*.[1,8]\" )
    FOREACH(MANPAGE \${MANPAGES})
      MESSAGE( \"-- Processing: \" \${MANPAGE} )
      EXECUTE_PROCESS(
        COMMAND cat \${MANPAGE}
        COMMAND sed  -e \"s/__VERSION__/${XROOTD_VERSION}/\"
        OUTPUT_FILE \${MANPAGE}.new )
      EXECUTE_PROCESS(
        COMMAND mv -f \${MANPAGE}.new \${MANPAGE} )
    ENDFOREACH()"
)
endif()

=== tests/CMakeLists.txt ===

add_subdirectory( common )
add_subdirectory( XrdClTests )
add_subdirectory( XrdSsiTests )

if( BUILD_XRDEC )
  add_subdirectory( XrdEcTests )
endif()

if( BUILD_CEPH )
  add_subdirectory( XrdCephTests )
endif()

=== bindings/python/CMakeLists.txt ===
--- 
+++ 
@@ -83,20 +83,27 @@
   install(
     CODE
     "EXECUTE_PROCESS(
+      RESULT_VARIABLE INSTALL_STATUS
       COMMAND /usr/bin/env ${XROOTD_PYBUILD_ENV} ${PYTHON_EXECUTABLE} ${SETUP_PY} install \
                 --verbose \
                 --prefix \$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX} \
                 ${DEB_INSTALL_ARGS}
-    )"
-  )
-
+    )
+    if(NOT INSTALL_STATUS EQUAL 0)
+      message(FATAL_ERROR \"Failed to install Python bindings\")
+    endif()
+  ")
 else()
   install(
     CODE
     "EXECUTE_PROCESS(
+      RESULT_VARIABLE INSTALL_STATUS
       COMMAND /usr/bin/env ${XROOTD_PYBUILD_ENV} ${PYTHON_EXECUTABLE} -m pip install \
                 ${PIP_OPTIONS} \
                 ${CMAKE_CURRENT_BINARY_DIR}
-      )"
-  )
+      )
+      if(NOT INSTALL_STATUS EQUAL 0)
+        message(FATAL_ERROR \"Failed to install Python bindings\")
+      endif()
+  ")
 endif()

=== src/XrdClHttp/CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,6 @@
 
 add_library(${PLUGIN_NAME} MODULE ${libXrdClHttp_sources})
 
-target_link_libraries(${PLUGIN_NAME} ${Davix_LIBRARIES} XrdCl)
+target_link_libraries(${PLUGIN_NAME} ${Davix_LIBRARIES} XrdCl XrdUtils)
 
 install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== debian/changelog ===
xrootd (5.5.3-1) unstable; urgency=medium

  * Update to version 5.5.3

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sat, 18 Feb 2023 13:45:08 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: xrootd
 Section: net
 Priority: optional
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Build-Depends:
  debhelper (>= 13),
  dh-python,

=== debian/rules ===
--- 
+++ 
@@ -57,13 +57,13 @@
 	mv bindings/python/docs/build/html bindings/python/docs/build/python )
 
 	# Service unit files
-	mkdir -p debian/tmp/usr/lib/systemd/system
-	install -m 644 packaging/common/xrootd@.service debian/tmp/usr/lib/systemd/system
-	install -m 644 packaging/common/xrootd@.socket debian/tmp/usr/lib/systemd/system
-	install -m 644 packaging/common/xrdhttp@.socket debian/tmp/usr/lib/systemd/system
-	install -m 644 packaging/common/cmsd@.service debian/tmp/usr/lib/systemd/system
-	install -m 644 packaging/common/frm_xfrd@.service debian/tmp/usr/lib/systemd/system
-	install -m 644 packaging/common/frm_purged@.service debian/tmp/usr/lib/systemd/system
+	mkdir -p debian/tmp/lib/systemd/system
+	install -m 644 packaging/common/xrootd@.service debian/tmp/lib/systemd/system
+	install -m 644 packaging/common/xrootd@.socket debian/tmp/lib/systemd/system
+	install -m 644 packaging/common/xrdhttp@.socket debian/tmp/lib/systemd/system
+	install -m 644 packaging/common/cmsd@.service debian/tmp/lib/systemd/system
+	install -m 644 packaging/common/frm_xfrd@.service debian/tmp/lib/systemd/system
+	install -m 644 packaging/common/frm_purged@.service debian/tmp/lib/systemd/system
 	mkdir -p debian/tmp/usr/lib/tmpfiles.d
 	install -m 644 packaging/rhel/xrootd.tmpfiles debian/tmp/usr/lib/tmpfiles.d/xrootd.conf
